Subject: ds/multi-pack-index (was Re: What's cooking in git.git (Jul 2018, #03; Wed, 25))

From: Derrick Stolee <[email-masked]>
Date: Wed, 1 Aug 2018 16:53:01 -0400

On 7/25/2018 6:13 PM, Junio C Hamano wrote:
> * ds/multi-pack-index (2018-07-20) 23 commits
>   - midx: clear midx on repack
>   - packfile: skip loading index if in multi-pack-index
>   - midx: prevent duplicate packfile loads
>   - midx: use midx in approximate_object_count
>   - midx: use existing midx when writing new one
>   - midx: use midx in abbreviation calculations
>   - midx: read objects from multi-pack-index
>   - config: create core.multiPackIndex setting
>   - midx: write object offsets
>   - midx: write object id fanout chunk
>   - midx: write object ids in a chunk
>   - midx: sort and deduplicate objects from packfiles
>   - midx: read pack names into array
>   - multi-pack-index: write pack names in chunk
>   - multi-pack-index: read packfile list
>   - packfile: generalize pack directory list
>   - t5319: expand test data
>   - multi-pack-index: load into memory
>   - midx: write header information to lockfile
>   - multi-pack-index: add 'write' verb
>   - multi-pack-index: add builtin
>   - multi-pack-index: add format details
>   - multi-pack-index: add design document
>
>   When there are too many packfiles in a repository (which is not
>   recommended), looking up an object in these would require
>   consulting many pack .idx files; a new mechanism to have a single
>   file that consolidates all of these .idx files is introduced.
>
>   Ready to move to 'next', with some known issues to be followed up?
>   cf. <[email-masked]>
I'm not sure if there is anything actionable for me to do in response to 
this message.
>   cf. <CAPig+cTU--KrGcv4C_CwBZEuec4dgm_tJqL=[email-masked]>
This message is in regard to UX around the usage output when the 
command-line arguments are incorrect. The recommendation is to 
explicitly state what the user did that is incorrect. For such a simple 
usage line, I don't think this is necessary. The message also included this:

> I wouldn't want to see a re-roll just for this, especially for such a
> long series. Perhaps such a change can be done as a follow-up patch by
> someone at some point.

If this is something we _really_ want to do, then I will tackle it in my follow-up series that adds a 'verify' verb (thus complicating the usage and giving me an opportunity to improve this area).

Thanks,
-Stolee